/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Aspicere2.
 *
 * The Initial Developer of the Original Code is
 * the Ghislain Hoffman Software Engineering Lab, INTEC, University Ghent.
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *   Bram Adams <bram_DOT_adams_AT_ugent_DOT_be>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

#ifndef MY_MEASUREMENTS_H
#define MY_MEASUREMENTS_H

#include "my_mem.h"
#include <stdio.h>

int g_g;
int g_h;

int g(int a){
  return g_g;
}

int h(int** b){
  return g_h;
}

void display(int a){
  switch(a){
  case -1:
    printf("PARAM_ERROR");
    break;
  case 0:
    printf("LINKED_ERROR");
    break;
  case 1:
    printf("OK");
    break;
  default:
    printf("************** %d **************",a);
  }
}

typedef int (*fun)(int,int**);

void test(fun func,int** b){
  for(g_mem=PARAM_ERROR;g_mem<=OK;g_mem++){
    for(g_a=PARAM_ERROR;g_a<=OK;g_a++){
      for(g_g=PARAM_ERROR;g_g<=OK;g_g++){
	for(g_h=PARAM_ERROR;g_h<=OK;g_h++){
	  display(g_mem);
	  printf("/");
	  display(g_a);
	  printf("/");
	  display(g_g);
	  printf("/");
	  display(g_h);
	  printf("\n");
	  display(func(g_a,b));	  
	  printf("\n");
	}
      }
    }
  }
}

#endif
